#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <asm/unistd.h>

int syscall (long rax, long rdi, long rsi, long rdx) {
  int result;
  asm ( 
    "syscall" 
    : "=a" (result)
    : "a" (rax), "D" (rdi), "S" (rsi), "d" (rdx)
  );
  return result;
}

int main () {
  char* filename = "output.txt";
  char* text = "Hallo\n";
  // int fd = creat (filename, S_IRUSR | S_IWUSR);
  int fd = syscall (__NR_creat, (long)filename, S_IRUSR | S_IWUSR, 0);
  // write (fd, text, strlen(text));
  syscall (__NR_write, fd, (long)text, strlen(text));
  // wir benutzen strlen und nicht sizeof, weil bei
  // sizeof noch das abschliessende Null-Byte mit
  // geschrieben wird.
  // close (fd);
  syscall (__NR_close, fd, 0, 0);
}

