#include <asm/unistd.h>

int syscall (long eax, long ebx, long ecx, long edx) {
  int result;
  asm ( 
    "syscall" 
    : "=a" (result)
    : "a" (eax), "D" (ebx), "S" (ecx), "d" (edx)
  );
  return result;
}

int main() {
  char vater[]="Ich bin der Vater.\n";
  int vlen=sizeof(vater);
  char sohn[]="Ich bin der Sohn.\n";
  int slen=sizeof(sohn);

  int pid=syscall(__NR_fork,0,0,0);

  if (pid) {
    // write(1,&vater,vlen);
    syscall (__NR_write, 1, (long)&vater, vlen);
  }
  else {
    // write(1,&sohn,slen);
    syscall (__NR_write, 1, (long)&sohn, slen);
  }
  return 0;
}

